<template>
    <v-container fluid>
        <v-form fast-fail @submit.prevent="addPermission" class="custom">
            <v-row>
                <v-col cols="6" md="3">
                    <div class="custom-label">Adı </div><br>
                    <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactForm.name" />
                    <div class="custom-label">Açıklama </div><br>
                    <v-text-field class="text-eureko" :disabled="false" v-model="reactForm.description"
                        variant="outlined" />
                </v-col>
                <v-col cols="6" md="3">
                    <div class="custom-label">Görünen Adı </div><br>
                    <v-text-field class="text-eureko" :disabled="false" v-model="reactForm.displayText"
                        variant="outlined" />
                </v-col>
            </v-row>
            <v-row>
                <v-col cols="12" md="12" justify="end" class="text-right">
                    <custom-button style="width: 120px;" color="primary" size="medium" val="Kaydet"
                        @click="addPermission" />
                </v-col>
            </v-row>
        </v-form>

        <AlertComponent :title="this.alert.title" :alert-text="this.alert.alertText" :alert-type="this.alert.alertType"
            ref="alertComponentRef" />
    </v-container>
</template>

<script>
import PermissionService from "@/services/PermissionService";
import CustomButton from '@/components/custom-controller/CustomButton.vue';
import AlertComponent from '@/components/alert-component/AlertComponent.vue';
import eventBus from '@/plugins/eventBus';
import { reactive, ref } from "vue";

export default {
    components: {
        CustomButton,
        AlertComponent,
    },
    setup() {
        const snackbar = ref(false);
        const errorMessage = ref('');
        const alertComponentRef = ref(null)
        const reactForm = reactive({
            name: "",
            description: "",
            displayText: ""
        });
        const alert = reactive({
            title: "",
            alertText: "",
            alertType: ""
        });
        const addPermission = () => {
            const request = {
                name: reactForm.name,
                description: reactForm.description,
                displayText: reactForm.displayText
            };

            PermissionService.AddPermission(request)
                .then(() => {
                    alert.title = "Başarılı";
                    alert.alertText = "İzin başarılı şekilde eklenmiştir";
                    alert.alertType = "success";
                    alertComponentRef.value.showTimedAlert();
                    localStorage.removeItem("permisssions");
                    eventBus.emit('permission-added');
                })
                .catch((error) => {
                    alert.title = "Başarısız";
                    alert.alertText = "İzin Eklenirken bir hata oluştu. Hata : " + error.ErrorMessage;
                    alert.alertType = "error";
                    alertComponentRef.value.showTimedAlert();
                });
        };

        return {
            snackbar,
            errorMessage,
            reactForm,
            alert,
            alertComponentRef,
            addPermission
        };

    },
};
</script>

<style scoped>
@import "@/assets/styles/custom/custom-input.css";
</style>
